/* KIT Tool | EneffBIM converter 2016  Version 0.1 (Author KIT BLM)
 * main.js
 *
 * JScript zur Transformation einer IFC Quelldatei in das designierte Zielformat durch den Einsatz von xsl stylesheet
 */
var args = WScript.Arguments;
var fso = new ActiveXObject("Scripting.FileSystemObject");

if (args.length == 0) {
    WScript.Echo("Please specify a source file to transform.");
    WScript.Quit();
}

// command-line argumente auslesen
var xmlfilename = args(0); // Quelldatei

// where are we working
var workingdir = WScript.scriptfullname.replace(WScript.scriptname, "");
WScript.Echo("Currently operating in: " + workingdir); 

// MS Documentation (https://msdn.microsoft.com/en-us/library/ms762312(v=vs.85).aspx)

var xslt = new ActiveXObject("Msxml2.XSLTemplate.6.0");  
var xsldoc = new ActiveXObject("Msxml2.FreeThreadedDOMDocument.6.0");
xsldoc.setProperty("AllowXsltScript", true);
xsldoc.setProperty("ResolveExternals", true);
xsldoc.setProperty("AllowDocumentFunction", true);
var xslproc;  

// Varia instead of using MappingRepository.XSL directly compute therein included JScript here and pass as PARAM
var filepath;
var txtfilename;
// Three possible (relative) pathes to the Mapping Table file (CSV) - we need to eval the workingdir path and choose accordingly.
var prepwdirpath = workingdir.split('\\').join('/')

// 1.) Development structure -"ROOT"\IFCtoSimModel\ReqCap\output
// Note: working directory (script location) is thereby "ROOT"\IFCtoSimModel\KIT\EnEffBIMConverter\Development\Main\main.JS
txtfilename = "11.csv";

// 2.) DIST structure -"ROOT"\IFCtoSimModel\ReqCap\output
// Note: working directory - shorter relative location! "ROOT"\IFCtoSimModel\KIT\EnEffBIMConverter\DIST\main.JS

// VARS for cases 1 and 2
var relativepath = "/ReqCap/output/"; 
var pathdelimiter = '/KIT/EnEffBIMConverter/';

if(fso.FolderExists(prepwdirpath.split(pathdelimiter)[0] + relativepath)) 
	filepath = prepwdirpath.split(pathdelimiter)[0] + relativepath + txtfilename;
else
{
	// 3.) PACKED RELEASE MODULE (nested) structure -"ROOT"\MappingTable\
	// Note: working directory - shorter relative location! "ROOT"\EnEffBIMConverter\main.JS
	txtfilename = "table.csv";
	filepath = prepwdirpath + "mapping/" + txtfilename;
}

WScript.Echo("Trying to read mapping table: " + filepath);
// parse the mappings txt file as string
//Create Stream object - needs ADO 2.5 or heigher
var BinaryStream = new ActiveXObject("ADODB.Stream");
       
//Specify stream type - we cheat and get string but 'like' binary
BinaryStream.Type = 2; // adTypeText   
BinaryStream.Charset = "utf-8";    
BinaryStream.LineSeparator = 10; // adLF
          
//Open the stream 
BinaryStream.Open();
       
//Load the file data from disk To stream object
BinaryStream.LoadFromFile(filepath);
        
//Open the stream And get binary 'string' from the object
var param = BinaryStream.ReadText;
        
// Clean up
BinaryStream.Close();

xsldoc.async = false;  
xsldoc.load(workingdir + "xsl\\Main.xsl");  

if (xsldoc.parseError.errorCode != 0) {  
   var myErr = xsldoc.parseError;  
   WScript.Echo("You have error " + myErr.reason);  
} else {

WScript.Echo("Loading of XSL succeeded.");

   xslt.stylesheet = xsldoc;  
   var xmldoc = new ActiveXObject("Msxml2.DOMDocument.6.0");  
   xmldoc.async = false;
   xmldoc.validateOnParse = true;
   xmldoc.load(xmlfilename);  
   if (xmldoc.parseError.errorCode != 0) {  
      var myErr = xmldoc.parseError;  
      WScript.Echo("You have error " + myErr.reason);  
   } else {  

WScript.Echo("Loading of XML succeeded.");
// Speichere Startzeit
var sTime = new Date();

      xslproc = xslt.createProcessor();  
      xslproc.input = xmldoc;  
      xslproc.addParameter("param_mappings", param);  
      xslproc.transform();
//      WScript.Echo(xslproc.output);  

//if (xslproc.transformError.errorCode != 0) {  
//   var myErr = xsldoc.parseError;  
//   WScript.Echo("You have error " + myErr.reason);  
//} else { 
//}

 var eTime = new Date();
 var elapsed = (eTime.getTime() - sTime.getTime()) / 1000;
 WScript.Echo("Successfully transformed XML in " + elapsed + " seconds.");

// Zieldokument in UTF-8-Stream schreiben
BinaryStream.Open();

BinaryStream.WriteText(xslproc.output);

BinaryStream.Position = 3; // Byte Order Mark berspringen

var outdir = workingdir + "output\\";

	// Ergebnis speichern
	try {   
		if(!fso.FolderExists(outdir)) fso.CreateFolder(outdir);
		var resultname = fso.GetBaseName(xmlfilename) + ".simxml";
	    	BinaryStream.SaveToFile( outdir + resultname, 2); // adSaveCreateOverWrite
	}
	catch(err) {  
    		WScript.Echo ("Output Error : " + err.number + "* " + err.description);
		BinaryStream.Close();
		WScript.Quit();  
	}
    	WScript.Echo("Saved transformation result ("+ resultname + ") to OUTPUT folder (" + outdir + ").");
    	BinaryStream.Close(); 
   }  
}  

