<?xml version="1.0" encoding="utf-8"?>
<!-- KIT Tool | EneffBIM converter 2016  Version 0.9 (Author KIT BLM) IfcHelper.xsl 2.5.2017 -->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns="http://d-alchemy.com/schema/simxml/Model" xmlns:simcore="http://d-alchemy.com/schema/simxml/SimModelCore" xmlns:simres="http://d-alchemy.com/schema/simxml/ResourcesGeneral" xmlns:simgeom="http://d-alchemy.com/schema/simxml/ResourcesGeometry" xmlns:simbldg="http://d-alchemy.com/schema/simxml/BuildingModel" xmlns:simmep="http://d-alchemy.com/schema/simxml/MepModel" xmlns:ifc="http://www.buildingsmart-tech.org/ifcXML/IFC4/Add1" xmlns:msxsl="urn:schemas-microsoft-com:xslt" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" exclude-result-prefixes="xsl ifc msxsl">
	<xsl:output method="xml" version="1.0" encoding="UTF-8" omit-xml-declaration="yes" indent="yes"/>
	<xsl:strip-space elements="*"/>
	<xsl:variable name="sourceobjects">
		<xsl:for-each select="/ifc:ifcXML/ifc:IfcProject">
			<xsl:if test="current()/ifc:IsDecomposedBy | current()/ifc:Declares">
				<xsl:call-template name="IfcProject"/>
			</xsl:if>
		</xsl:for-each>
	</xsl:variable>
	<xsl:variable name="rootchildren">
		<xsl:for-each select="/ifc:ifcXML/node()">
			<xsl:if test="not(contains(name(), 'IfcProject'))">
				<xsl:copy-of select="current()"/>
			</xsl:if>
		</xsl:for-each>
	</xsl:variable>
	<xsl:variable name="allsourceobjects">
		<xsl:copy-of select="$sourceobjects"/>
		<xsl:copy-of select="$rootchildren"/>
	</xsl:variable>
	<xsl:template name="IterateAllSourceObjects">
		<xsl:for-each select="msxsl:node-set($allsourceobjects)/node()">
			<xsl:variable name="currentElem" select="current()"/>
			<xsl:choose>
				<xsl:when test="current()/ifc:IsDecomposedBy/ifc:IfcRelAggregates/ifc:RelatedObjects/ifc:IfcGroup[@GlobalId]">
					<xsl:for-each select="current()/ifc:IsDecomposedBy/ifc:IfcRelAggregates/ifc:RelatedObjects/ifc:IfcGroup[@GlobalId]">
						<xsl:call-template name="KeyPoolHelper">
							<xsl:with-param name="currentElement" select="name()"/>
							<xsl:with-param name="parentElement" select="$currentElem"/>
						</xsl:call-template>
					</xsl:for-each>
					<xsl:call-template name="KeyPoolHelper">
						<xsl:with-param name="currentElement" select="name()"/>
					</xsl:call-template>
				</xsl:when>
				<xsl:when test="current()/ifc:IsNestedBy/ifc:IfcRelNests/ifc:RelatedObjects/ifc:IfcDistributionPort">
					<xsl:if test="current()/ifc:IsNestedBy/ifc:IfcRelNests/ifc:RelatedObjects/ifc:IfcDistributionPort[@GlobalId]">
						<xsl:for-each select="current()/ifc:IsNestedBy/ifc:IfcRelNests/ifc:RelatedObjects/ifc:IfcDistributionPort">
							<xsl:if test="current()[@GlobalId]">
								<xsl:call-template name="KeyPoolHelper">
									<xsl:with-param name="currentElement" select="name()"/>
									<xsl:with-param name="parentElement" select="$currentElem"/>
								</xsl:call-template>
							</xsl:if>
						</xsl:for-each>
						<xsl:call-template name="KeyPoolHelper">
							<xsl:with-param name="currentElement" select="name()"/>
						</xsl:call-template>
					</xsl:if>
				</xsl:when>
				<xsl:when test="current()/ifc:RelatedObjects/ifc:IfcDistributionPort | current()/ifc:RelatingGroup">
					<xsl:for-each select="current()/ifc:RelatedObjects/ifc:IfcDistributionPort">
						<xsl:if test="current()[@GlobalId]">
							<xsl:call-template name="KeyPoolHelper">
								<xsl:with-param name="currentElement" select="'ifc:IfcDistributionPort'"/>
								<xsl:with-param name="parentElement" select="$currentElem"/>
							</xsl:call-template>
						</xsl:if>
					</xsl:for-each>
					<xsl:if test="current()/ifc:RelatingGroup[@GlobalId]">
						<xsl:for-each select="current()/ifc:RelatingGroup">
							<xsl:variable name="typename" select="@xsi:type"/>
							<xsl:call-template name="KeyPoolHelper">
								<xsl:with-param name="currentElement" select="normalize-space($typename)"/>
								<xsl:with-param name="parentElement" select="'whoami'"/>
							</xsl:call-template>
						</xsl:for-each>
					</xsl:if>
					<xsl:call-template name="KeyPoolHelper">
						<xsl:with-param name="currentElement" select="name()"/>
					</xsl:call-template>
				</xsl:when>
				<xsl:otherwise>
					<xsl:choose>
						<xsl:when test="local-name() = 'IfcSystem' and not(current()/ifc:IsDecomposedBy/ifc:IfcRelAggregates/ifc:RelatedObjects)">
							<xsl:variable name="idval" select="@id"/>
							<xsl:variable name="parentSystem">
								<xsl:for-each select="msxsl:node-set($allsourceobjects)/node()">
									<xsl:if test="local-name() = 'IfcSystem' and @GlobalId and current()/ifc:IsDecomposedBy/ifc:IfcRelAggregates/ifc:RelatedObjects/*[@href = $idval]">
										<xsl:value-of select="./@GlobalId"/>
									</xsl:if>
								</xsl:for-each>
							</xsl:variable>
							<xsl:call-template name="KeyPoolHelper">
								<xsl:with-param name="currentElement" select="name()"/>
								<xsl:with-param name="parentElement" select="$parentSystem"/>
							</xsl:call-template>
						</xsl:when>
						<xsl:otherwise>
							<xsl:call-template name="KeyPoolHelper">
								<xsl:with-param name="currentElement" select="name()"/>
							</xsl:call-template>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:for-each>
	</xsl:template>
	<xsl:template name="TargetValueFormatConditions">
		<xsl:param name="sourcename"/>
		<xsl:param name="sourcevalue"/>
		<xsl:param name="targetname"/>
		<xsl:variable name="addedvalue">
			<xsl:if test="$sourcename = 'GlobalId'">
				<xsl:value-of select="concat('ID',$sourcevalue)"/>
			</xsl:if>
		</xsl:variable>
		<xsl:choose>
			<xsl:when test="not(contains($targetname,'UniqueID'))">
				<xsl:call-template name="remove">
					<xsl:with-param name="input">
						<xsl:value-of select="$addedvalue"/>
					</xsl:with-param>
					<xsl:with-param name="removal" select="'$'"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$addedvalue"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
</xsl:stylesheet>
