<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:ifc="http://www.buildingsmart-tech.org/ifcXML/IFC4/Add1" xmlns="http://d-alchemy.com/schema/simxml/Model" xmlns:simcore="http://d-alchemy.com/schema/simxml/SimModelCore" xmlns:simres="http://d-alchemy.com/schema/simxml/ResourcesGeneral" xmlns:simgeom="http://d-alchemy.com/schema/simxml/ResourcesGeometry" xmlns:simbldg="http://d-alchemy.com/schema/simxml/BuildingModel" xmlns:simmep="http://d-alchemy.com/schema/simxml/MepModel" xmlns:msxsl="urn:schemas-microsoft-com:xslt" exclude-result-prefixes="xsl ifc msxsl">
	<xsl:template name="IfcPropertySet">
		<xsl:param name="KeyPool"/>
		<xsl:param name="preEvaluation"/>
		<xsl:param name="elementId"/>
		<xsl:if test="$KeyPool != '' or $preEvaluation != ''">
			<xsl:choose>
				<xsl:when test="current()[@GlobalId]">
					<xsl:variable name="psetname" select="current()/@Name"/>
					<xsl:if test="$psetname = 'PSim_Controller' and $preEvaluation = ''">
						<xsl:call-template name="resolvekeypool">
							<xsl:with-param name="KeyPoolSnippet" select="$KeyPool"/>
							<xsl:with-param name="psetname" select="$psetname"/>
							<xsl:with-param name="pname" select="' '"/>
							<xsl:with-param name="pvalue" select="' '"/>
							<xsl:with-param name="preEvaluation" select="$preEvaluation"/>
							<xsl:with-param name="elementId" select="$elementId"/>
						</xsl:call-template>
					</xsl:if>
					<xsl:for-each select="current()/ifc:HasProperties/node()">
						<xsl:choose>
							<xsl:when test="not(current()[@ref | @href])">
								<xsl:variable name="pname" select="current()/@Name"/>
								<xsl:variable name="pvalue" select="."/>
								<xsl:call-template name="resolvekeypool">
									<xsl:with-param name="KeyPoolSnippet" select="$KeyPool"/>
									<xsl:with-param name="psetname" select="$psetname"/>
									<xsl:with-param name="pname" select="$pname"/>
									<xsl:with-param name="pvalue" select="$pvalue"/>
									<xsl:with-param name="preEvaluation" select="$preEvaluation"/>
									<xsl:with-param name="elementId" select="$elementId"/>
								</xsl:call-template>
							</xsl:when>
							<xsl:otherwise>
								<xsl:if test="@ref | @href">
									<xsl:variable name="pid">
										<xsl:copy>
											<xsl:value-of select="@ref | @href"/>
										</xsl:copy>
									</xsl:variable>
									<xsl:for-each select="msxsl:node-set($allsourceobjects)/*[@id]">
										<xsl:if test="current()[contains(@id,$pid)]">
											<xsl:variable name="pname" select="current()/@Name"/>
											<xsl:variable name="pvalue" select="."/>
											<xsl:call-template name="resolvekeypool">
												<xsl:with-param name="KeyPoolSnippet" select="$KeyPool"/>
												<xsl:with-param name="psetname" select="$psetname"/>
												<xsl:with-param name="pname" select="$pname"/>
												<xsl:with-param name="pvalue" select="$pvalue"/>
												<xsl:with-param name="preEvaluation" select="$preEvaluation"/>
												<xsl:with-param name="elementId" select="$elementId"/>
											</xsl:call-template>
										</xsl:if>
									</xsl:for-each>
								</xsl:if>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:for-each>
				</xsl:when>
				<xsl:when test="current()/@ref | current()/@href">
					<xsl:variable name="refid" select="current()/@ref | current()/@href"/>
					<xsl:for-each select="msxsl:node-set($allsourceobjects)/*/ifc:IfcPropertySet">
						<xsl:if test="current()[contains(@id,$refid)]">
							<xsl:if test="current()[@GlobalId]">
								<xsl:variable name="psetname" select="current()/@Name"/>
								<xsl:if test="$psetname = 'PSim_Controller'">
									<xsl:call-template name="resolvekeypool">
										<xsl:with-param name="KeyPoolSnippet" select="$KeyPool"/>
										<xsl:with-param name="psetname" select="$psetname"/>
										<xsl:with-param name="pname" select="' '"/>
										<xsl:with-param name="pvalue" select="' '"/>
										<xsl:with-param name="preEvaluation" select="$preEvaluation"/>
										<xsl:with-param name="elementId" select="$elementId"/>
									</xsl:call-template>
								</xsl:if>
								<xsl:for-each select="current()/ifc:HasProperties/node()">
									<xsl:choose>
										<xsl:when test="not(current()[@ref | @href])">
											<xsl:variable name="pname" select="current()/@Name"/>
											<xsl:variable name="pvalue" select="."/>
											<xsl:call-template name="resolvekeypool">
												<xsl:with-param name="KeyPoolSnippet" select="$KeyPool"/>
												<xsl:with-param name="psetname" select="$psetname"/>
												<xsl:with-param name="pname" select="$pname"/>
												<xsl:with-param name="pvalue" select="$pvalue"/>
												<xsl:with-param name="preEvaluation" select="$preEvaluation"/>
												<xsl:with-param name="elementId" select="$elementId"/>
											</xsl:call-template>
										</xsl:when>
										<xsl:otherwise>
											<xsl:if test="@ref | @href">
												<xsl:variable name="pid">
													<xsl:copy>
														<xsl:value-of select="@ref | @href"/>
													</xsl:copy>
												</xsl:variable>
												<xsl:for-each select="msxsl:node-set($allsourceobjects)/*[@id]">
													<xsl:if test="current()[contains(@id,$pid)]">
														<xsl:variable name="pname" select="current()/@Name"/>
														<xsl:variable name="pvalue" select="."/>
														<xsl:call-template name="resolvekeypool">
															<xsl:with-param name="KeyPoolSnippet" select="$KeyPool"/>
															<xsl:with-param name="psetname" select="$psetname"/>
															<xsl:with-param name="pname" select="$pname"/>
															<xsl:with-param name="pvalue" select="$pvalue"/>
															<xsl:with-param name="preEvaluation" select="$preEvaluation"/>
															<xsl:with-param name="elementId" select="$elementId"/>
														</xsl:call-template>
													</xsl:if>
												</xsl:for-each>
											</xsl:if>
										</xsl:otherwise>
									</xsl:choose>
								</xsl:for-each>
							</xsl:if>
						</xsl:if>
					</xsl:for-each>
				</xsl:when>
			</xsl:choose>
		</xsl:if>
	</xsl:template>
	<xsl:template name="resolveReferenceProperty">
		<xsl:if test="local-name() = 'IfcPropertyReferenceValue'">
			<xsl:for-each select="current()/ifc:PropertyReference/node()">
				<xsl:variable name="buildKeyPool">
					<xsl:call-template name="KeyPoolBuilder">
						<xsl:with-param name="ElementName" select="local-name()"/>
					</xsl:call-template>
				</xsl:variable>
				<xsl:apply-templates select="current()">
					<xsl:with-param name="KeyPool" select="$buildKeyPool"/>
				</xsl:apply-templates>
			</xsl:for-each>
		</xsl:if>
	</xsl:template>
	<xsl:template name="ResolveIfcRelDefinesByProperties">
		<xsl:for-each select=".">
			<xsl:variable name="elemid">
				<xsl:copy>
					<xsl:value-of select="@id"/>
				</xsl:copy>
			</xsl:variable>
			<xsl:if test="$elemid != ''">
				<xsl:for-each select="msxsl:node-set($allsourceobjects)/ifc:IfcRelDefinesByProperties/ifc:RelatedObjects">
					<xsl:if test="current()[contains(@ref, $elemid)] | current()[contains(@href, $elemid)]">
						<xsl:for-each select="../ifc:RelatingPropertyDefinition/ifc:IfcPropertySet">
							<xsl:copy-of select="current()"/>
						</xsl:for-each>
					</xsl:if>
				</xsl:for-each>
				<xsl:if test="current()/ifc:IsDefinedBy">
					<xsl:for-each select="current()/ifc:IsDefinedBy/ifc:IfcRelDefinesByProperties/ifc:RelatingPropertyDefinition/ifc:IfcPropertySet">
						<xsl:copy-of select="current()"/>
					</xsl:for-each>
				</xsl:if>
			</xsl:if>
		</xsl:for-each>
	</xsl:template>
	<xsl:template name="GenerateDuplicateList">
		<xsl:param name="PSByRelDef"/>
		<xsl:param name="PSByType"/>
		<xsl:for-each select="msxsl:node-set($PSByType)/ifc:IfcPropertySet/ifc:HasProperties/node()">
			<xsl:variable name="Name" select="@Name"/>
			<xsl:variable name="psetName" select="../../@Name"/>
			<xsl:variable name="psetGlobalID" select="../../@GlobalId"/>
			<xsl:for-each select="msxsl:node-set($PSByRelDef)/ifc:IfcPropertySet/ifc:HasProperties/node()">
				<xsl:variable name="RelDefPropertyName" select="@Name"/>
				<xsl:variable name="RelDefPropertySetName" select="../../@Name"/>
				<xsl:if test="current()[../../@Name = $psetName]">
					<xsl:if test="$Name = $RelDefPropertyName">
						<xsl:value-of select="$psetGlobalID"/>
					</xsl:if>
				</xsl:if>
			</xsl:for-each>
		</xsl:for-each>
	</xsl:template>
	<xsl:template name="DuplicateFilterSourceObjectPropertyCollectionMerge">
		<xsl:param name="firstCollection"/>
		<xsl:param name="secondCollection"/>
		<xsl:variable name="DuplicateIDList">
			<xsl:call-template name="GenerateDuplicateList">
				<xsl:with-param name="PSByRelDef" select="$firstCollection"/>
				<xsl:with-param name="PSByType" select="$secondCollection"/>
			</xsl:call-template>
		</xsl:variable>
		<xsl:for-each select="msxsl:node-set($secondCollection)/node()">
			<xsl:variable name="currentID">
				<xsl:value-of select="current()/@GlobalId"/>
			</xsl:variable>
			<xsl:if test="not(contains($DuplicateIDList,$currentID))">
				<xsl:copy-of select="current()"/>
			</xsl:if>
		</xsl:for-each>
		<xsl:copy-of select="$firstCollection"/>
	</xsl:template>
	<xsl:template name="tryAssembleTargetElement">
		<xsl:param name="input"/>
		<xsl:variable name="filterAllElement01Contents">
			<xsl:call-template name="filterAllOtherContents">
				<xsl:with-param name="input" select="$input"/>
				<xsl:with-param name="token" select="'eeBIMprv01_FLAG_'"/>
			</xsl:call-template>
		</xsl:variable>
		<xsl:variable name="filterAllElement02Contents">
			<xsl:call-template name="filterAllOtherContents">
				<xsl:with-param name="input" select="$input"/>
				<xsl:with-param name="token" select="'eeBIMprv02_FLAG_'"/>
			</xsl:call-template>
		</xsl:variable>
		<xsl:variable name="filterAllElement03Contents">
			<xsl:call-template name="filterAllOtherContents">
				<xsl:with-param name="input" select="$input"/>
				<xsl:with-param name="token" select="'eeBIMprv03_FLAG_'"/>
			</xsl:call-template>
		</xsl:variable>
		<xsl:choose>
			<xsl:when test="$filterAllElement01Contents != 'FALSE'">
				<xsl:call-template name="FillSceleton">
					<xsl:with-param name="taggedTargetContent" select="$filterAllElement01Contents"/>
					<xsl:with-param name="prefixToken" select="'eeBIMprv01_FLAG_'"/>
				</xsl:call-template>
				<xsl:if test="$filterAllElement02Contents != 'FALSE'">
					<xsl:call-template name="FillSceleton">
						<xsl:with-param name="taggedTargetContent" select="$filterAllElement02Contents"/>
						<xsl:with-param name="prefixToken" select="'eeBIMprv02_FLAG_'"/>
					</xsl:call-template>
				</xsl:if>
				<xsl:if test="$filterAllElement03Contents != 'FALSE'">
					<xsl:call-template name="FillSceleton">
						<xsl:with-param name="taggedTargetContent" select="$filterAllElement03Contents"/>
						<xsl:with-param name="prefixToken" select="'eeBIMprv03_FLAG_'"/>
					</xsl:call-template>
				</xsl:if>
			</xsl:when>
			<xsl:otherwise>
							FALSE
				</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="resolveRefPropContent">
		<xsl:param name="KeyPool"/>
		<xsl:param name="parentid"/>
		<xsl:param name="token"/>
		<xsl:variable name="cleanedupKeyPool">
			<xsl:call-template name="CleanPool">
				<xsl:with-param name="KeyPool" select="substring-before($KeyPool, '§')"/>
			</xsl:call-template>
		</xsl:variable>
		<xsl:choose>
			<xsl:when test="contains($KeyPool, '§') and not(substring-after(substring-before($cleanedupKeyPool, ' Sim'), ' ')=local-name())">
				<xsl:variable name="elemname" select="substring-after(substring-after($cleanedupKeyPool, ' Sim'), ':')"/>
				<xsl:if test="$elemname != ''">
					<xsl:variable name="current_FLAG" select="substring-before(substring-after($cleanedupKeyPool, ' Sim'), '.')"/>
					<xsl:variable name="currenttoken">
						<xsl:choose>
							<xsl:when test="$current_FLAG = 'TimeSeriesSchedule_Year_Default'">eeBIMprv01_FLAG_</xsl:when>
							<xsl:when test="$current_FLAG = 'TimeSeriesSchedule_Week_Daily'">eeBIMprv02_FLAG_</xsl:when>
							<xsl:when test="$current_FLAG = 'TimeSeriesSchedule_Day_Interval'">eeBIMprv03_FLAG_</xsl:when>
						</xsl:choose>
					</xsl:variable>
					<xsl:if test="$currenttoken = $token">
						<xsl:element name="{normalize-space(concat($token, $elemname))}">
							<xsl:value-of select="concat(substring-after(substring-after($cleanedupKeyPool, ' Sim'), '.'),' ')"/>
							<xsl:variable name="tryGetAttributeOrFieldValue">
								<xsl:choose>
									<xsl:when test="contains(substring-after($cleanedupKeyPool,'###.###.'), 'CB_1')">
										<xsl:choose>
											<xsl:when test="starts-with(substring-after(substring-after($cleanedupKeyPool,'###.###.'), 'CB_1.'), 'ID')">
												<xsl:value-of select="substring-before(substring-after(substring-after($cleanedupKeyPool,'###.###.'), 'CB_1.'), ' ')"/>
												<xsl:value-of select="substring-after(substring-after($parentid, '_'), '_')"/>
											</xsl:when>
											<xsl:otherwise>
												<xsl:value-of select="$parentid"/>
											</xsl:otherwise>
										</xsl:choose>
									</xsl:when>
									<xsl:when test="contains(substring-after($cleanedupKeyPool,'###.###.'), 'substring(')">
										<xsl:variable name="substrargs" select="substring-before(substring-after($cleanedupKeyPool,'###.###.substring(' ), ')' )"/>
										<xsl:variable name="firstarg">
											<xsl:value-of select="@*[local-name() = substring-before($substrargs, ',')]"/>
										</xsl:variable>
										<xsl:variable name="secondarg">
											<xsl:value-of select="substring-before(substring-after($substrargs, ','), ',')"/>
										</xsl:variable>
										<xsl:variable name="thirdarg">
											<xsl:value-of select="substring-after(substring-after($substrargs, ','), ',')"/>
										</xsl:variable>
										<xsl:value-of select="substring($firstarg,$secondarg,$thirdarg)"/>
									</xsl:when>
									<xsl:when test="not(contains(substring-before(substring-after($cleanedupKeyPool,'###.###.'), ' '), '.'))">
										<xsl:value-of select="@*[local-name() = substring-before(substring-after($cleanedupKeyPool,'###.###.'), ' ')]"/>
										<xsl:for-each select="current()/node()">
											<xsl:if test="contains(substring-before(substring-after($cleanedupKeyPool,'###.###.'),' '), local-name()) and current()/*/*/node()">
												<xsl:for-each select="current()/*/*/node()">
													<xsl:variable name="posint" select="position()"/>
													<xsl:choose>
														<xsl:when test="substring-after($cleanedupKeyPool, '__') != ''">
															<xsl:variable name="staticval">
																<xsl:variable name="term" select="substring-before(substring-after($cleanedupKeyPool,'__'), ' ')"/>
																<xsl:variable name="int" select="substring-before(substring-after($term, '_'), '_')"/>
																<xsl:variable name="resint" select="$int +1 - $posint"/>
																<xsl:value-of select="concat(substring-before($term, '_'),': ')"/>
																<xsl:value-of select="concat($resint, ':')"/>
																<xsl:value-of select="substring-after(substring-after($term, '_'), '_')"/>
															</xsl:variable>
															<xsl:variable name="itemtype" select="'simcore:stringItem'"/>
															<xsl:value-of select="concat(concat(concat('__',$itemtype),'__'),$staticval)"/>
														</xsl:when>
														<xsl:otherwise>
															<xsl:value-of select="concat(.,' ')"/>
														</xsl:otherwise>
													</xsl:choose>
												</xsl:for-each>
											</xsl:if>
										</xsl:for-each>
									</xsl:when>
									<xsl:otherwise>
									</xsl:otherwise>
								</xsl:choose>
							</xsl:variable>
							<xsl:choose>
								<xsl:when test="$tryGetAttributeOrFieldValue != ''">
									<xsl:value-of select="$tryGetAttributeOrFieldValue"/>
								</xsl:when>
								<xsl:otherwise>
									<xsl:value-of select="substring-before(substring-after($cleanedupKeyPool,'###.###.'), ' ')"/>
								</xsl:otherwise>
							</xsl:choose>
						</xsl:element>
					</xsl:if>
				</xsl:if>
				<xsl:call-template name="resolveRefPropContent">
					<xsl:with-param name="KeyPool" select="substring-after($KeyPool, '§')"/>
					<xsl:with-param name="parentid" select="$parentid"/>
					<xsl:with-param name="token" select="$token"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
				<xsl:if test="contains($KeyPool, '§')">
					<xsl:call-template name="resolveRefPropContent">
						<xsl:with-param name="KeyPool" select="substring-after($KeyPool, '§')"/>
						<xsl:with-param name="parentid" select="$parentid"/>
						<xsl:with-param name="token" select="$token"/>
					</xsl:call-template>
				</xsl:if>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="CleanPool">
		<xsl:param name="KeyPool"/>
		<xsl:if test="contains($KeyPool,'###.###.')">
			<xsl:if test="contains(substring-after($KeyPool,'###.###.'), ' ') and starts-with(substring-after(substring-after($KeyPool,'###.###.'), ' '), 'Sim')">
				<xsl:value-of select="substring-after($KeyPool,' ')"/>
			</xsl:if>
			<xsl:call-template name="CleanPool">
				<xsl:with-param name="KeyPool" select="substring-after($KeyPool, '###.###.')"/>
			</xsl:call-template>
		</xsl:if>
	</xsl:template>
	<xsl:template name="tryAssembleTargetFromComplexProperty">
		<xsl:param name="input"/>
		<xsl:variable name="filterAllComplexPropertyContents">
			<xsl:call-template name="filterAllOtherContents">
				<xsl:with-param name="input" select="$input"/>
				<xsl:with-param name="token" select="'eeBIMcp_FLAG_'"/>
			</xsl:call-template>
		</xsl:variable>
		<xsl:choose>
			<xsl:when test="$filterAllComplexPropertyContents != 'FALSE'">
				<xsl:call-template name="FillSceleton">
					<xsl:with-param name="taggedTargetContent" select="$filterAllComplexPropertyContents"/>
					<xsl:with-param name="prefixToken" select="'eeBIMcp_FLAG_'"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
							FALSE
				</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
</xsl:stylesheet>
