<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns="http://d-alchemy.com/schema/simxml/Model" xmlns:simcore="http://d-alchemy.com/schema/simxml/SimModelCore" xmlns:simres="http://d-alchemy.com/schema/simxml/ResourcesGeneral" xmlns:simgeom="http://d-alchemy.com/schema/simxml/ResourcesGeometry" xmlns:simbldg="http://d-alchemy.com/schema/simxml/BuildingModel" xmlns:simmep="http://d-alchemy.com/schema/simxml/MepModel" xmlns:ifc="http://www.buildingsmart-tech.org/ifcXML/IFC4/Add1" xmlns:missingSub="http://subnamespace.undeclared" xmlns:msxsl="urn:schemas-microsoft-com:xslt" exclude-result-prefixes="xsl ifc msxsl">
	<xsl:template name="resolvekeypool">
		<xsl:param name="KeyPoolSnippet"/>
		<xsl:param name="elemname"/>
		<xsl:param name="psetname"/>
		<xsl:param name="pname"/>
		<xsl:param name="pvalue"/>
		<xsl:param name="preEvaluation"/>
		<xsl:param name="parentElement"/>
		<xsl:param name="elementId"/>
		<xsl:choose>
			<xsl:when test="contains($KeyPoolSnippet, '§') and ($psetname != '' and contains($KeyPoolSnippet, $psetname) or $elemname != '')">
				<xsl:call-template name="resolvekeypoolpairs">
					<xsl:with-param name="KeyPoolSnippet" select="substring-before($KeyPoolSnippet, '§')"/>
					<xsl:with-param name="elemname" select="$elemname"/>
					<xsl:with-param name="psetname" select="$psetname"/>
					<xsl:with-param name="pname" select="$pname"/>
					<xsl:with-param name="pvalue" select="$pvalue"/>
					<xsl:with-param name="preEvaluation" select="$preEvaluation"/>
					<xsl:with-param name="parentElement" select="$parentElement"/>
					<xsl:with-param name="elementId" select="$elementId"/>
				</xsl:call-template>
				<xsl:call-template name="resolvekeypool">
					<xsl:with-param name="KeyPoolSnippet" select="substring-after($KeyPoolSnippet, '§')"/>
					<xsl:with-param name="elemname" select="$elemname"/>
					<xsl:with-param name="psetname" select="$psetname"/>
					<xsl:with-param name="pname" select="$pname"/>
					<xsl:with-param name="pvalue" select="$pvalue"/>
					<xsl:with-param name="preEvaluation" select="$preEvaluation"/>
					<xsl:with-param name="parentElement" select="$parentElement"/>
					<xsl:with-param name="elementId" select="$elementId"/>
				</xsl:call-template>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="resolvekeypoolpairs">
		<xsl:param name="KeyPoolSnippet"/>
		<xsl:param name="elemname"/>
		<xsl:param name="psetname"/>
		<xsl:param name="pname"/>
		<xsl:param name="pvalue"/>
		<xsl:param name="preEvaluation"/>
		<xsl:param name="parentElement"/>
		<xsl:param name="elementId"/>
		<xsl:if test="contains($KeyPoolSnippet, ' ')">
			<xsl:variable name="simkey" select="substring-after($KeyPoolSnippet, ' ')"/>
			<xsl:choose>
				<xsl:when test="starts-with($simkey, 'Sim')">
					<xsl:variable name="subComplexProp">
						<xsl:choose>
							<xsl:when test="contains( substring-after( substring-after( substring-before($KeyPoolSnippet, ' '), concat($elemname, '.')) ,'.') , '.')">
								<xsl:value-of select="substring-after( substring-after( substring-after( substring-before($KeyPoolSnippet, ' '), concat($elemname, '.')) ,'.') , '.')"/>
							</xsl:when>
						</xsl:choose>
					</xsl:variable>
					<xsl:variable name="simprop">
						<xsl:choose>
							<xsl:when test="contains(substring-after($simkey,'.'), '.')">
								<xsl:value-of select="substring-before(substring-after($simkey,'.'), '.')"/>
							</xsl:when>
							<xsl:otherwise>
								<xsl:value-of select="substring-after($simkey,'.')"/>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:variable>
					<xsl:variable name="simdesignatedvalue">
						<xsl:choose>
							<xsl:when test="contains(substring-after($simkey,'.'), '.')">
								<xsl:value-of select="substring-after(substring-after($simkey, '.'), '.')"/>
							</xsl:when>
							<xsl:otherwise>FALSE</xsl:otherwise>
						</xsl:choose>
					</xsl:variable>
					<xsl:variable name="simpropfullname">
						<xsl:choose>
							<xsl:when test="not(contains($simprop,':'))">
								<xsl:value-of select="concat('missingSub:',$simprop)"/>
							</xsl:when>
							<xsl:otherwise>
								<xsl:choose>
									<xsl:when test="contains($simprop, '.')">
									</xsl:when>
									<xsl:otherwise>
										<xsl:value-of select="$simprop"/>
									</xsl:otherwise>
								</xsl:choose>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:variable>
					<xsl:choose>
						<xsl:when test="$elemname != '' and $psetname = '' and $simprop != ''">
							<xsl:variable name="ifckey" select="substring-before($KeyPoolSnippet, ' ')"/>
							<xsl:variable name="ifcgloid" select="@GlobalId"/>
							<xsl:variable name="elementchildren">
								<xsl:value-of select="concat($elemname, '.')">
								</xsl:value-of>
							</xsl:variable>
							<xsl:variable name="elementancestor">
								<xsl:value-of select="concat('.', $elemname)"/>
							</xsl:variable>
							<xsl:variable name="checkall">
								<xsl:value-of select="concat('.', $elementchildren)"/>
							</xsl:variable>
							<xsl:variable name="nestingpathfromparent">
								<xsl:value-of select="substring-before($ifckey,$elementancestor)"/>
							</xsl:variable>
							<xsl:variable name="nestingpathtochild">
								<xsl:value-of select="substring-after($ifckey,$elementchildren)"/>
							</xsl:variable>
							<xsl:variable name="generateContents">
								<xsl:choose>
									<xsl:when test="contains($ifckey,'###.###.')">
										<xsl:value-of select="substring-after($ifckey,'###.###.')"/>
									</xsl:when>
									<xsl:otherwise>
										<xsl:variable name="resolvepathtochild">
											<xsl:variable name="levelonekey">
												<xsl:choose>
													<xsl:when test="contains( $nestingpathtochild, '.')">
														<xsl:value-of select="substring-before( $nestingpathtochild, '.')"/>
													</xsl:when>
													<xsl:otherwise>
														<xsl:value-of select="$nestingpathtochild"/>
													</xsl:otherwise>
												</xsl:choose>
											</xsl:variable>
											<xsl:choose>
												<xsl:when test="@*[local-name() = substring-after($ifckey, $elementchildren)] != ''">
													<xsl:value-of select="@*[local-name() = substring-after($ifckey, $elementchildren)]"/>
												</xsl:when>
												<xsl:otherwise>
													<xsl:variable name="levelonevalue">
														<xsl:if test="$levelonekey != ''">
															<xsl:choose>
																<xsl:when test="@*[name() = $levelonekey]">
																</xsl:when>
																<xsl:when test="current()/*[local-name() = $levelonekey]">
																</xsl:when>
															</xsl:choose>
														</xsl:if>
													</xsl:variable>
													<xsl:variable name="nestingpathfromlevelone" select="substring-after($nestingpathtochild, concat($levelonekey, '.'))"/>
													<xsl:variable name="leveltwokey">
														<xsl:choose>
															<xsl:when test="$nestingpathfromlevelone != '' and contains($nestingpathfromlevelone, '.')">
																<xsl:value-of select="substring-before($nestingpathfromlevelone, '.')"/>
															</xsl:when>
															<xsl:otherwise>
																<xsl:value-of select="$nestingpathfromlevelone"/>
															</xsl:otherwise>
														</xsl:choose>
													</xsl:variable>
													<xsl:variable name="nestingpathfromleveltwo" select="substring-after($nestingpathfromlevelone, concat($leveltwokey, '.'))"/>
													<xsl:variable name="levelthreekey">
														<xsl:choose>
															<xsl:when test="$nestingpathfromleveltwo != '' and contains($nestingpathfromleveltwo, '.')">
																<xsl:value-of select="substring-before($nestingpathfromleveltwo, '.')"/>
															</xsl:when>
															<xsl:otherwise>
																<xsl:value-of select="$nestingpathfromleveltwo"/>
															</xsl:otherwise>
														</xsl:choose>
													</xsl:variable>
													<xsl:variable name="nestingpathfromlevelthree" select="substring-after($nestingpathfromleveltwo, concat($levelthreekey, '.'))"/>
													<xsl:variable name="levelfourkey">
														<xsl:choose>
															<xsl:when test="$nestingpathfromlevelthree != '' and contains($nestingpathfromlevelthree, '.')">
																<xsl:value-of select="substring-before($nestingpathfromlevelthree, '.')"/>
															</xsl:when>
															<xsl:otherwise>
																<xsl:value-of select="$nestingpathfromlevelthree"/>
															</xsl:otherwise>
														</xsl:choose>
													</xsl:variable>
													<xsl:variable name="referencetargetid" select="@id"/>
													<xsl:for-each select="msxsl:node-set($allsourceobjects)/node()">
														<xsl:if test="local-name() = $leveltwokey">
															<xsl:for-each select="descendant-or-self::node()">
																<xsl:if test="local-name() = $levelonekey">
																	<xsl:choose>
																		<xsl:when test="./node()">
																			<xsl:for-each select="./node()">
																				<xsl:if test="current()[@ref = $referencetargetid] | current()[@href = $referencetargetid]">
																					<xsl:for-each select="../../child::*">
																						<xsl:if test="local-name() = $levelthreekey">
																							<xsl:choose>
																								<xsl:when test="current()/@*[local-name() = $levelfourkey]">
																									<xsl:for-each select="current()/@*">
																										<xsl:if test="local-name() = $levelfourkey">
																											<xsl:call-template name="TargetValueFormatConditions">
																												<xsl:with-param name="sourcename">
																													<xsl:value-of select="$levelfourkey"/>
																												</xsl:with-param>
																												<xsl:with-param name="sourcevalue">
																													<xsl:value-of select="."/>
																												</xsl:with-param>
																												<xsl:with-param name="targetname">
																													<xsl:value-of select="$simpropfullname"/>
																												</xsl:with-param>
																											</xsl:call-template>
																											<xsl:value-of select="' '"/>
																										</xsl:if>
																									</xsl:for-each>
																								</xsl:when>
																								<xsl:when test="current()/@*[local-name() = 'href']">
																									<xsl:for-each select="current()/@*">
																										<xsl:if test="local-name() = 'href'">
																											<xsl:variable name="refid" select="."/>
																											<xsl:for-each select="msxsl:node-set($allsourceobjects)/descendant-or-self::node()">
																												<xsl:if test="@id = $refid">
																													<xsl:call-template name="TargetValueFormatConditions">
																														<xsl:with-param name="sourcename">
																															<xsl:value-of select="$levelfourkey"/>
																														</xsl:with-param>
																														<xsl:with-param name="sourcevalue">
																															<xsl:value-of select="@*[local-name() = $levelfourkey]"/>
																														</xsl:with-param>
																														<xsl:with-param name="targetname">
																															<xsl:value-of select="$simpropfullname"/>
																														</xsl:with-param>
																													</xsl:call-template>
																													<xsl:value-of select="' '"/>
																												</xsl:if>
																											</xsl:for-each>
																										</xsl:if>
																									</xsl:for-each>
																								</xsl:when>
																								<xsl:otherwise>
																								</xsl:otherwise>
																							</xsl:choose>
																						</xsl:if>
																					</xsl:for-each>
																				</xsl:if>
																			</xsl:for-each>
																		</xsl:when>
																		<xsl:when test="current()[@ref = $referencetargetid] | current()[@href = $referencetargetid]">
																			<xsl:for-each select=".">
																				<xsl:for-each select=".././node()">
																					<xsl:if test="local-name() = $levelthreekey">
																						<xsl:choose>
																							<xsl:when test="./@*[local-name() = 'ref'] | ./@*[local-name() = 'href']">
																								<xsl:for-each select="./@*[local-name() = 'ref'] | ./@*[local-name() = 'href']">
																									<xsl:variable name="refkey">
																										<xsl:value-of select="."/>
																									</xsl:variable>
																									<xsl:for-each select="msxsl:node-set($allsourceobjects)/descendant-or-self::node()">
																										<xsl:if test="@id = $refkey">
																											<xsl:call-template name="TargetValueFormatConditions">
																												<xsl:with-param name="sourcename">
																													<xsl:value-of select="$levelfourkey"/>
																												</xsl:with-param>
																												<xsl:with-param name="sourcevalue">
																													<xsl:value-of select="@*[local-name() = $levelfourkey]"/>
																												</xsl:with-param>
																												<xsl:with-param name="targetname">
																													<xsl:value-of select="$simpropfullname"/>
																												</xsl:with-param>
																											</xsl:call-template>
																										</xsl:if>
																									</xsl:for-each>
																								</xsl:for-each>
																							</xsl:when>
																							<xsl:when test="./*/@*[local-name() = 'ref'] | ./*/@*[local-name() = 'href'] or ./*/@*[local-name() = 'id']">
																								<xsl:for-each select="./*/@*[local-name() = 'ref'] | ./*/@*[local-name() = 'href']">
																									<xsl:variable name="refkey">
																										<xsl:value-of select="."/>
																									</xsl:variable>
																									<xsl:for-each select="msxsl:node-set($allsourceobjects)/node()">
																										<xsl:if test="@id = $refkey">
																											<xsl:call-template name="TargetValueFormatConditions">
																												<xsl:with-param name="sourcename">
																													<xsl:value-of select="$levelfourkey"/>
																												</xsl:with-param>
																												<xsl:with-param name="sourcevalue">
																													<xsl:value-of select="@*[local-name() = $levelfourkey]"/>
																												</xsl:with-param>
																												<xsl:with-param name="targetname">
																													<xsl:value-of select="$simpropfullname"/>
																												</xsl:with-param>
																											</xsl:call-template>
																										</xsl:if>
																									</xsl:for-each>
																									<xsl:value-of select="' '"/>
																								</xsl:for-each>
																								<xsl:for-each select="./*/node()">
																									<xsl:if test="@*[local-name() = 'id']">
																										<xsl:variable name="idkey">
																											<xsl:value-of select="@id"/>
																										</xsl:variable>
																										<xsl:call-template name="TargetValueFormatConditions">
																											<xsl:with-param name="sourcename">
																												<xsl:value-of select="$levelfourkey"/>
																											</xsl:with-param>
																											<xsl:with-param name="sourcevalue">
																												<xsl:value-of select="@*[local-name() = $levelfourkey]"/>
																											</xsl:with-param>
																											<xsl:with-param name="targetname">
																												<xsl:value-of select="$simpropfullname"/>
																											</xsl:with-param>
																										</xsl:call-template>
																										<xsl:value-of select="' '"/>
																									</xsl:if>
																								</xsl:for-each>
																							</xsl:when>
																							<xsl:otherwise>
																							</xsl:otherwise>
																						</xsl:choose>
																					</xsl:if>
																				</xsl:for-each>
																			</xsl:for-each>
																		</xsl:when>
																	</xsl:choose>
																</xsl:if>
															</xsl:for-each>
														</xsl:if>
													</xsl:for-each>
												</xsl:otherwise>
											</xsl:choose>
										</xsl:variable>
										<xsl:variable name="resolvepathfromparent">
											<xsl:variable name="levelonekey">
												<xsl:choose>
													<xsl:when test="contains( $nestingpathfromparent, '.')">
														<xsl:call-template name="lastofpath">
															<xsl:with-param name="pathsnippet" select="$nestingpathfromparent"/>
														</xsl:call-template>
													</xsl:when>
													<xsl:otherwise>
														<xsl:value-of select="$nestingpathfromparent"/>
													</xsl:otherwise>
												</xsl:choose>
											</xsl:variable>
											<xsl:choose>
												<xsl:when test="@*[local-name() = $levelonekey] != ''">
													<xsl:value-of select="@*[local-name() = $levelonekey]"/>
												</xsl:when>
												<xsl:otherwise>
													<xsl:variable name="nestingpathfromlevelone" select="substring-before($nestingpathfromparent, concat('.', $levelonekey))"/>
													<xsl:variable name="leveltwokey">
														<xsl:choose>
															<xsl:when test="$nestingpathfromlevelone != '' and contains($nestingpathfromlevelone, '.')">
																<xsl:call-template name="lastofpath">
																	<xsl:with-param name="pathsnippet" select="$nestingpathfromlevelone"/>
																</xsl:call-template>
															</xsl:when>
															<xsl:otherwise>
																<xsl:value-of select="$nestingpathfromlevelone"/>
															</xsl:otherwise>
														</xsl:choose>
													</xsl:variable>
													<xsl:variable name="nestingpathfromleveltwo" select="substring-before($nestingpathfromlevelone, concat('.', $leveltwokey))"/>
													<xsl:variable name="levelthreekey">
														<xsl:choose>
															<xsl:when test="$nestingpathfromleveltwo != '' and contains($nestingpathfromleveltwo, '.')">
																<xsl:call-template name="lastofpath">
																	<xsl:with-param name="pathsnippet" select="$nestingpathfromleveltwo"/>
																</xsl:call-template>
															</xsl:when>
															<xsl:otherwise>
																<xsl:value-of select="$nestingpathfromleveltwo"/>
															</xsl:otherwise>
														</xsl:choose>
													</xsl:variable>
													<xsl:variable name="nestingpathfromlevelthree" select="substring-before($nestingpathfromleveltwo, concat('.', $levelthreekey))"/>
													<xsl:variable name="levelfourkey">
														<xsl:choose>
															<xsl:when test="$nestingpathfromlevelthree != '' and contains($nestingpathfromlevelthree, '.')">
																<xsl:call-template name="lastofpath">
																	<xsl:with-param name="pathsnippet" select="$nestingpathfromlevelthree"/>
																</xsl:call-template>
															</xsl:when>
															<xsl:otherwise>
																<xsl:value-of select="$nestingpathfromlevelthree"/>
															</xsl:otherwise>
														</xsl:choose>
													</xsl:variable>
													<xsl:variable name="checkedvalue">
														<xsl:choose>
															<xsl:when test="msxsl:node-set($parentElement)/@*[local-name() = $levelfourkey]">
																<xsl:value-of select="msxsl:node-set($parentElement)/@*[local-name() = $levelfourkey]"/>
															</xsl:when>
															<xsl:when test="$parentElement != ''">
																<xsl:value-of select="$parentElement"/>
															</xsl:when>
														</xsl:choose>
													</xsl:variable>
													<xsl:variable name="levelonevalue">
														<xsl:if test="$levelonekey != ''">
														</xsl:if>
													</xsl:variable>
													<xsl:choose>
														<xsl:when test="$checkedvalue != '' and (contains($simpropfullname, 'simres:HostElement') or contains($simpropfullname, 'simcore:ParentGroups') or contains($simpropfullname, 'simbldg:ParentSystem'))">
															<xsl:call-template name="TargetValueFormatConditions">
																<xsl:with-param name="sourcename">
																	<xsl:value-of select="$levelfourkey"/>
																</xsl:with-param>
																<xsl:with-param name="sourcevalue">
																	<xsl:value-of select="$checkedvalue"/>
																</xsl:with-param>
																<xsl:with-param name="targetname">
																	<xsl:value-of select="$simpropfullname"/>
																</xsl:with-param>
															</xsl:call-template>
														</xsl:when>
														<xsl:when test="$levelonevalue != ''">
															<xsl:copy-of select="$levelonevalue"/>
														</xsl:when>
														<xsl:otherwise>
															<xsl:variable name="referencetargetid" select="@id"/>
															<xsl:for-each select="msxsl:node-set($allsourceobjects)/node()">
																<xsl:if test="local-name() = $leveltwokey">
																	<xsl:for-each select="descendant-or-self::node()">
																		<xsl:if test="local-name() = $levelonekey">
																			<xsl:for-each select=".">
																				<xsl:if test="current()[@ref = $referencetargetid] | current()[@href = $referencetargetid]">
																					<xsl:for-each select=".././*">
																						<xsl:if test="local-name() = $levelthreekey">
																							<xsl:for-each select="./@*[local-name() = 'ref'] | ./@*[local-name() = 'href']">
																								<xsl:variable name="refkey">
																									<xsl:value-of select="."/>
																								</xsl:variable>
																								<xsl:for-each select="msxsl:node-set($allsourceobjects)/node()">
																									<xsl:if test="@id = $refkey">
																										<xsl:call-template name="TargetValueFormatConditions">
																											<xsl:with-param name="sourcename">
																												<xsl:value-of select="$levelfourkey"/>
																											</xsl:with-param>
																											<xsl:with-param name="sourcevalue">
																												<xsl:value-of select="@*[local-name() = $levelfourkey]"/>
																											</xsl:with-param>
																											<xsl:with-param name="targetname">
																												<xsl:value-of select="$simpropfullname"/>
																											</xsl:with-param>
																										</xsl:call-template>
																									</xsl:if>
																								</xsl:for-each>
																							</xsl:for-each>
																						</xsl:if>
																					</xsl:for-each>
																				</xsl:if>
																			</xsl:for-each>
																		</xsl:if>
																	</xsl:for-each>
																</xsl:if>
															</xsl:for-each>
														</xsl:otherwise>
													</xsl:choose>
												</xsl:otherwise>
											</xsl:choose>
										</xsl:variable>
										<xsl:choose>
											<xsl:when test="contains($ifckey, $checkall)">
												<xsl:choose>
													<xsl:when test="$resolvepathfromparent = $resolvepathtochild and ($resolvepathtochild != '' or $resolvepathfromparent != '')">
														<xsl:value-of select="$resolvepathfromparent"/>
													</xsl:when>
													<xsl:when test="$resolvepathtochild = '' and '' != $resolvepathfromparent">
														<xsl:value-of select="$resolvepathfromparent"/>
													</xsl:when>
													<xsl:when test="$resolvepathfromparent = '' and '' != $resolvepathtochild">
														<xsl:value-of select="$resolvepathtochild"/>
													</xsl:when>
													<xsl:otherwise>
														<xsl:value-of select="$resolvepathtochild"/>
													</xsl:otherwise>
												</xsl:choose>
											</xsl:when>
											<xsl:when test="contains($ifckey, $elementancestor)">
												<xsl:choose>
													<xsl:when test="$resolvepathfromparent != ''">
														<xsl:value-of select="$resolvepathfromparent"/>
													</xsl:when>
													<xsl:otherwise>
													</xsl:otherwise>
												</xsl:choose>
											</xsl:when>
											<xsl:when test="starts-with($ifckey, $elementchildren)">
												<xsl:choose>
													<xsl:when test="$resolvepathtochild !=  ''">
														<xsl:value-of select="$resolvepathtochild"/>
													</xsl:when>
													<xsl:otherwise>
													</xsl:otherwise>
												</xsl:choose>
											</xsl:when>
											<xsl:otherwise>
											</xsl:otherwise>
										</xsl:choose>
									</xsl:otherwise>
								</xsl:choose>
							</xsl:variable>
							<xsl:if test="$generateContents !=''">
								<xsl:element name="{normalize-space($simpropfullname)}">
									<xsl:copy-of select="$generateContents"/>
								</xsl:element>
							</xsl:if>
						</xsl:when>
						<xsl:when test="not($pname = '') and contains($KeyPoolSnippet, $psetname) and contains($KeyPoolSnippet, $pname)">
							<xsl:choose>
								<xsl:when test="$preEvaluation != ''">
									<xsl:variable name="currentTestString">
										<xsl:call-template name="ToLower">
											<xsl:with-param name="input" select="concat(concat(concat(concat(../../@Name, '.'), @Name), '.'), $pvalue)"/>
										</xsl:call-template>
									</xsl:variable>
									<xsl:variable name="conditionTestString">
										<xsl:call-template name="ToLower">
											<xsl:with-param name="input" select="$preEvaluation"/>
										</xsl:call-template>
									</xsl:variable>
									<xsl:choose>
										<xsl:when test="$conditionTestString = $currentTestString">TRUE</xsl:when>
										<xsl:otherwise>
											FALSE
										</xsl:otherwise>
									</xsl:choose>
								</xsl:when>
								<xsl:otherwise>
									<xsl:choose>
										<xsl:when test="(contains(../../@Name, 'PSim_Controller') or @Name = 'PSim_Controller') and not(local-name() = 'IfcPropertyReferenceValue')">
											<xsl:choose>
												<xsl:when test="@Name = 'PSim_Controller' and contains($KeyPoolSnippet, 'GlobalId')">
													<xsl:element name="{normalize-space(concat('eeBIMc_FLAG_', 'SimDummy'))}">
														<xsl:value-of select="substring-after($simpropfullname, ':')"/>
														<xsl:value-of select="concat(' ID_cntrl_', $elementId)"/>
													</xsl:element>
												</xsl:when>
												<xsl:when test="@Name = 'PSim_Controller' and contains($KeyPoolSnippet, 'AssignedToFlowElement') and $elementId != ''">
													<xsl:element name="{normalize-space(concat('eeBIMc_FLAG_', substring-after($simpropfullname, ':')))}">
														<xsl:value-of select="concat($simpropfullname,' ')"/>
														<xsl:value-of select="concat(' ID', $elementId)"/>
													</xsl:element>
												</xsl:when>
												<xsl:otherwise>
													<xsl:element name="{normalize-space(concat('eeBIMc_FLAG_', substring-after($simpropfullname, ':')))}">
														<xsl:value-of select="concat($simpropfullname,' ')"/>
														<xsl:value-of select="$pvalue"/>
													</xsl:element>
												</xsl:otherwise>
											</xsl:choose>
										</xsl:when>
										<xsl:when test="local-name() = 'IfcComplexProperty'">
											<xsl:choose>
												<xsl:when test="@Name = 'PartialLoadEfficiencyCurves' and $subComplexProp = 'GlobalId'">
													<xsl:element name="{normalize-space(concat('eeBIMcp_FLAG_', 'SimDummy'))}">
														<xsl:value-of select="substring-after($simpropfullname, ':')"/>
														<xsl:value-of select="concat(' ID_cp_', $elementId)"/>
													</xsl:element>
												</xsl:when>
												<xsl:when test="@Name = 'PartialLoadEfficiencyCurves' and $subComplexProp != ''">
													<xsl:for-each select="./ifc:HasProperties/node()">
														<xsl:if test="@Name = $subComplexProp">
															<xsl:element name="{normalize-space(concat('eeBIMcp_FLAG_', substring-after($simpropfullname, ':')))}">
																<xsl:value-of select="concat($simpropfullname,' ')"/>
																<xsl:value-of select="."/>
															</xsl:element>
														</xsl:if>
													</xsl:for-each>
												</xsl:when>
												<xsl:when test="@Name = 'PartialLoadEfficiencyCurves'">
													<xsl:element name="{normalize-space($simpropfullname)}">
														<xsl:value-of select="concat(' ID_cp_', $elementId)"/>
													</xsl:element>
												</xsl:when>
												<xsl:otherwise>
													<xsl:if test="$subComplexProp != ''">
														<xsl:element name="{normalize-space($simpropfullname)}">
															<xsl:for-each select="./ifc:HasProperties/node()">
																<xsl:if test="@Name = $subComplexProp">
																	<xsl:value-of select="."/>
																</xsl:if>
															</xsl:for-each>
														</xsl:element>
													</xsl:if>
												</xsl:otherwise>
											</xsl:choose>
										</xsl:when>
										<xsl:when test="local-name() = 'IfcPropertyReferenceValue'">
											<xsl:element name="{normalize-space($simpropfullname)}">
												<xsl:value-of select="concat('ID_prv01_', $elementId)"/>
											</xsl:element>
											<xsl:for-each select="current()/ifc:PropertyReference/node()">
												<xsl:variable name="KeyPool">
													<xsl:call-template name="KeyPoolBuilder">
														<xsl:with-param name="ElementName" select="local-name()"/>
													</xsl:call-template>
												</xsl:variable>
												<xsl:if test="$KeyPool != ''">
													<xsl:variable name="simelemname">
														<xsl:call-template name="getTargetElementNames">
															<xsl:with-param name="KeyPool" select="$KeyPool"/>
														</xsl:call-template>
													</xsl:variable>
													<xsl:if test="contains($simelemname, ' ') and substring-before(substring-after($simelemname, ' '), ' ')">
														<xsl:element name="{normalize-space(concat('eeBIMprv01_FLAG_', 'SimDummy'))}">
															<xsl:value-of select="substring-before(substring-after($simelemname, ' '), ' ')"/>
															<xsl:value-of select="concat(' ID_prv01_', $elementId)"/>
														</xsl:element>
														<xsl:call-template name="resolveRefPropContent">
															<xsl:with-param name="KeyPool" select="$KeyPool"/>
															<xsl:with-param name="parentid" select="concat('_prv01_', $elementId)"/>
															<xsl:with-param name="token" select="'eeBIMprv01_FLAG_'"/>
														</xsl:call-template>
													</xsl:if>
													<xsl:if test="contains(substring-after($simelemname, ' '), ' ') and substring-before(substring-after(substring-after($simelemname, ' '), ' '), ' ')">
														<xsl:element name="{normalize-space(concat('eeBIMprv02_FLAG_', 'SimDummy'))}">
															<xsl:value-of select="substring-before(substring-after(substring-after($simelemname, ' '), ' '), ' ')"/>
															<xsl:value-of select="concat(' ID_prv02_', $elementId)"/>
														</xsl:element>
														<xsl:call-template name="resolveRefPropContent">
															<xsl:with-param name="KeyPool" select="$KeyPool"/>
															<xsl:with-param name="parentid" select="concat('_prv02_', $elementId)"/>
															<xsl:with-param name="token" select="'eeBIMprv02_FLAG_'"/>
														</xsl:call-template>
													</xsl:if>
													<xsl:if test="contains(substring-after(substring-after($simelemname, ' '), ' '), ' ') and substring-after(substring-after(substring-after($simelemname, ' '), ' '), ' ')">
														<xsl:element name="{normalize-space(concat('eeBIMprv03_FLAG_', 'SimDummy'))}">
															<xsl:value-of select="substring-after(substring-after(substring-after($simelemname, ' '), ' '), ' ')"/>
															<xsl:value-of select="concat(' ID_prv03_', $elementId)"/>
														</xsl:element>
														<xsl:call-template name="resolveRefPropContent">
															<xsl:with-param name="KeyPool" select="$KeyPool"/>
															<xsl:with-param name="parentid" select="concat('_prv03_', $elementId)"/>
															<xsl:with-param name="token" select="'eeBIMprv03_FLAG_'"/>
														</xsl:call-template>
													</xsl:if>
												</xsl:if>
											</xsl:for-each>
										</xsl:when>
										<xsl:otherwise>
											<xsl:choose>
												<xsl:when test="$simdesignatedvalue != 'FALSE'">
													<xsl:element name="{normalize-space($simpropfullname)}">
														<xsl:value-of select="$simdesignatedvalue"/>
													</xsl:element>
												</xsl:when>
												<xsl:when test="$subComplexProp != ''">
													<xsl:element name="{normalize-space($simpropfullname)}">
														<xsl:for-each select="./ifc:HasProperties/node()">
															<xsl:if test="@Name = $subComplexProp">
																<xsl:value-of select="."/>
															</xsl:if>
														</xsl:for-each>
													</xsl:element>
												</xsl:when>
												<xsl:when test="$simdesignatedvalue = 'FALSE'">
													<xsl:element name="{normalize-space($simpropfullname)}">
														<xsl:value-of select="$pvalue"/>
													</xsl:element>
												</xsl:when>
												<xsl:otherwise>
												</xsl:otherwise>
											</xsl:choose>
										</xsl:otherwise>
									</xsl:choose>
								</xsl:otherwise>
							</xsl:choose>
						</xsl:when>
					</xsl:choose>
				</xsl:when>
				<xsl:otherwise>
					<xsl:if test="contains($simkey,' ')">
						<xsl:call-template name="resolvekeypoolpairs">
							<xsl:with-param name="KeyPoolSnippet" select="substring-after($KeyPoolSnippet, ' ' )"/>
							<xsl:with-param name="elemname" select="$elemname"/>
							<xsl:with-param name="psetname" select="$psetname"/>
							<xsl:with-param name="pname" select="$pname"/>
							<xsl:with-param name="pvalue" select="$pvalue"/>
							<xsl:with-param name="preEvaluation" select="$preEvaluation"/>
							<xsl:with-param name="parentElement" select="$parentElement"/>
						</xsl:call-template>
					</xsl:if>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:if>
	</xsl:template>
	<xsl:template name="extractfistvalue">
		<xsl:param name="input"/>
		<xsl:param name="delimiter"/>
		<xsl:value-of select="substring-after($input, $delimiter)"/>
	</xsl:template>
	<xsl:template name="lastofpath">
		<xsl:param name="pathsnippet"/>
		<xsl:choose>
			<xsl:when test="contains($pathsnippet, '.')">
				<xsl:call-template name="lastofpath">
					<xsl:with-param name="pathsnippet">
						<xsl:call-template name="extractfistvalue">
							<xsl:with-param name="input" select="$pathsnippet"/>
							<xsl:with-param name="delimiter" select="'.'"/>
						</xsl:call-template>
					</xsl:with-param>
					<xsl:with-param name="delimiter" select="'.'"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$pathsnippet"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="getglobalid">
		<xsl:param name="breadcrum"/>
		<xsl:for-each select="msxsl:node-set($allsourceobjects)/node()">
			<xsl:if test="@id = $breadcrum and @GlobalId">
				<xsl:value-of select="@GlobalId"/>
			</xsl:if>
		</xsl:for-each>
		<xsl:apply-templates/>
	</xsl:template>
</xsl:stylesheet>
