<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:ifc="http://www.buildingsmart-tech.org/ifcXML/IFC4/Add1" exclude-result-prefixes="xsl ifc">
	<xsl:output method="xml" version="1.0" encoding="UTF-8" indent="yes"/>
	<xsl:strip-space elements="*"/>
	<xsl:param name="param_mappings" select="/.."/>
	<xsl:include href="MappingRepository.xsl"/>
	<xsl:include href="KeyPoolBuilder.xsl"/>
	<xsl:include href="KeyPoolHelper.xsl"/>
	<xsl:include href="KeyBoundElementGenerator.xsl"/>
	<xsl:include href="SimXsdRrepository.xsl"/>
	<xsl:include href="GenerateTargetElement.xsl"/>
	<xsl:include href="IfcPropertySet.xsl"/>
	<xsl:include href="IfcType.xsl"/>
	<xsl:include href="IfcController.xsl"/>
	<xsl:include href="IfcHelper.xsl"/>
	<xsl:include href="ifcXML.xsl"/>
	<xsl:include href="IfcProject.xsl"/>
	<xsl:include href="IfcSite.xsl"/>
	<xsl:include href="IfcBuilding.xsl"/>
	<xsl:include href="IfcBuildingStorey.xsl"/>
	<xsl:include href="IfcSpace.xsl"/>
	<xsl:include href="IfcSystem.xsl"/>
	<xsl:include href="IfcBuildingSystem.xsl"/>
	<xsl:include href="IfcDistributionSystem.xsl"/>
	<xsl:include href="IfcDistributionPort.xsl"/>
	<xsl:include href="IfcRelConnectsPorts.xsl"/>
	<xsl:include href="IfcSpaceHeater.xsl"/>
	<xsl:include href="IfcOccupant.xsl"/>
	<xsl:include href="IfcActor.xsl"/>
	<xsl:include href="IfcBoiler.xsl"/>
	<xsl:include href="IfcTank.xsl"/>
	<xsl:include href="IfcValve.xsl"/>
	<xsl:include href="IfcPump.xsl"/>
	<xsl:include href="IfcPipeSegment.xsl"/>
	<xsl:include href="IfcPipeFitting.xsl"/>
	<xsl:include href="IfcZone.xsl"/>
	<xsl:include href="IfcGroup.xsl"/>
	<xsl:variable name="conf_optional_absolute_filepath" select="'mapping/'"/>
	<xsl:variable name="conf_mapping_table_filename" select="'table.csv'"/>
	<xsl:variable name="conf_relative_path_from_install_root" select="'/ReqCap/output/'"/>
	<xsl:variable name="conf_path_delimiter_to_install_root" select="'/KIT/EnEffBIMConverter/'"/>
	<xsl:variable name="GetMappingTable">
		<xsl:choose>
			<xsl:when test="$param_mappings"><xsl:copy-of select="$param_mappings"/></xsl:when>
			<xsl:otherwise><xsl:copy-of select="$getMappingTable_msxsl"/></xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="simmodel">
		<xsl:copy-of select="document('../schema/simmodel.xsd')"/>
	</xsl:variable>
	<xsl:variable name="simcore">
		<xsl:copy-of select="document('../schema/simcore.xsd')"/>
	</xsl:variable>
	<xsl:variable name="simres">
		<xsl:copy-of select="document('../schema/simres.xsd')"/>
	</xsl:variable>
	<xsl:variable name="simgeom">
		<xsl:copy-of select="document('../schema/simgeom.xsd')"/>
	</xsl:variable>
	<xsl:variable name="simbldg">
		<xsl:copy-of select="document('../schema/simbldg.xsd')"/>
	</xsl:variable>
	<xsl:variable name="simmep">
		<xsl:copy-of select="document('../schema/simmep.xsd')"/>
	</xsl:variable>
	<xsl:template match="/">
		<xsl:if test="ifc:ifcXML">
			<xsl:call-template name="ifcXML"/>
		</xsl:if>
	</xsl:template>
	<xsl:template match="text()"/>
</xsl:stylesheet>
