<?xml version="1.0" encoding="utf-8"?>
<!-- KIT Tool | EneffBIM converter 2016  Version 0.9 (Author KIT BLM) SimXsdRrepository.xsl 2.5.2017 -->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns="http://d-alchemy.com/schema/simxml/Model" xmlns:simcore="http://d-alchemy.com/schema/simxml/SimModelCore" xmlns:simres="http://d-alchemy.com/schema/simxml/ResourcesGeneral" xmlns:simgeom="http://d-alchemy.com/schema/simxml/ResourcesGeometry" xmlns:simbldg="http://d-alchemy.com/schema/simxml/BuildingModel" xmlns:simmep="http://d-alchemy.com/schema/simxml/MepModel" xmlns:ifc="http://www.buildingsmart-tech.org/ifcXML/IFC4/Add1" xmlns:xs="http://www.w3.org/2001/XMLSchema" xmlns:msxsl="urn:schemas-microsoft-com:xslt" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" exclude-result-prefixes="xsl ifc msxsl">
	<xsl:output method="xml" version="1.0" encoding="UTF-8" omit-xml-declaration="yes" indent="yes"/>
	<xsl:strip-space elements="*"/>
	<xsl:variable name="vSchema">
		<xsl:copy-of select="$simmodel"/>
		<xsl:copy-of select="$simres"/>
		<xsl:copy-of select="$simmep"/>
		<xsl:copy-of select="$simgeom"/>
		<xsl:copy-of select="$simcore"/>
		<xsl:copy-of select="$simbldg"/>
	</xsl:variable>
	<xsl:template name="IterateAlongSequenceOrder">
		<xsl:param name="KeyPool"/>
		<xsl:param name="CurrentSimElementName"/>
		<xsl:param name="preEvaluation"/>
		<xsl:param name="unsortedtargetcontent"/>
		<xsl:choose>
			<xsl:when test="$preEvaluation != ''">
				<xsl:copy-of select="$unsortedtargetcontent"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:for-each select="msxsl:node-set($vSchema)">
					<xsl:choose>
						<xsl:when test="$CurrentSimElementName != 'SimModel'">
							<xsl:apply-templates select="key('kxsComplexTypeByName', $CurrentSimElementName)">
								<xsl:with-param name="pElement" select="$CurrentSimElementName"/>
								<xsl:with-param name="pUnsortedItemList" select="$unsortedtargetcontent"/>
							</xsl:apply-templates>
						</xsl:when>
						<xsl:when test="$CurrentSimElementName = 'SimModel'">
							<xsl:apply-templates select="key('kxsElementByName', $CurrentSimElementName)">
								<xsl:with-param name="pElement" select="$CurrentSimElementName"/>
								<xsl:with-param name="pUnsortedItemList" select="$unsortedtargetcontent"/>
							</xsl:apply-templates>
						</xsl:when>
					</xsl:choose>
				</xsl:for-each>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<xsl:key name="kxsComplexTypeByName" match="xs:complexType" use="@name"/>
	<xsl:key name="kxsComplexTypeByName_simmodel" match="xs:complexType" use="@name"/>
	<xsl:key name="kxsComplexTypeByName_simcore" match="xs:complexType" use="@name"/>
	<xsl:key name="kxsComplexTypeByName_simres" match="xs:complexType" use="@name"/>
	<xsl:key name="kxsComplexTypeByName_simgeom" match="xs:complexType" use="@name"/>
	<xsl:key name="kxsComplexTypeByName_simbldg" match="xs:complexType" use="@name"/>
	<xsl:key name="kxsComplexTypeByName_simmep" match="xs:complexType" use="@name"/>
	<xsl:key name="kxsElementByName" match="xs:element" use="@name"/>
	<xsl:template match="xs:complexType">
		<xsl:param name="pElement"/>
		<xsl:param name="pUnsortedItemList"/>
		<xsl:variable name="base">
			<xsl:choose>
				<xsl:when test="current()/xs:complexContent/xs:extension[@base]">
					<xsl:value-of select="current()/xs:complexContent/xs:extension/@base"/>
				</xsl:when>
			</xsl:choose>
		</xsl:variable>
		<xsl:choose>
			<xsl:when test="current()/xs:sequence/xs:element">
				<xsl:apply-templates mode="generate" select="current()/xs:sequence/xs:element">
					<xsl:with-param name="pParent" select="$pElement"/>
					<xsl:with-param name="pUnsortedItemList" select="$pUnsortedItemList"/>
				</xsl:apply-templates>
			</xsl:when>
			<xsl:otherwise>
				<xsl:if test="$base != ''">
					<xsl:variable name="subnamespace" select="substring-before($base,':')"/>
					<xsl:variable name="localname" select="substring-after($base,':')"/>
					<xsl:choose>
						<xsl:when test="$subnamespace = 'simmodel'">
							<xsl:for-each select="msxsl:node-set($simmodel)">
								<xsl:apply-templates select="key('kxsComplexTypeByName_simmodel', $base)">
									<xsl:with-param name="pElement" select="localname"/>
									<xsl:with-param name="pUnsortedItemList" select="$pUnsortedItemList"/>
								</xsl:apply-templates>
							</xsl:for-each>
						</xsl:when>
						<xsl:when test="$subnamespace = 'simcore'">
							<xsl:for-each select="msxsl:node-set($simcore)">
								<xsl:apply-templates select="key('kxsComplexTypeByName_simcore', $localname)">
									<xsl:with-param name="pElement" select="localname"/>
									<xsl:with-param name="pUnsortedItemList" select="$pUnsortedItemList"/>
								</xsl:apply-templates>
							</xsl:for-each>
						</xsl:when>
						<xsl:when test="$subnamespace = 'simres'">
							<xsl:for-each select="msxsl:node-set($simres)">
								<xsl:apply-templates select="key('kxsComplexTypeByName_simres', $localname)">
									<xsl:with-param name="pElement" select="localname"/>
									<xsl:with-param name="pUnsortedItemList" select="$pUnsortedItemList"/>
								</xsl:apply-templates>
							</xsl:for-each>
						</xsl:when>
						<xsl:when test="$subnamespace = 'simgeom'">
							<xsl:for-each select="msxsl:node-set($simgeom)">
								<xsl:apply-templates select="key('kxsComplexTypeByName_simgeom', $localname)">
									<xsl:with-param name="pElement" select="localname"/>
									<xsl:with-param name="pUnsortedItemList" select="$pUnsortedItemList"/>
								</xsl:apply-templates>
							</xsl:for-each>
						</xsl:when>
						<xsl:when test="$subnamespace = 'simbldg'">
							<xsl:for-each select="msxsl:node-set($simbldg)">
								<xsl:apply-templates select="key('kxsComplexTypeByName_simbldg', $localname)">
									<xsl:with-param name="pElement" select="localname"/>
									<xsl:with-param name="pUnsortedItemList" select="$pUnsortedItemList"/>
								</xsl:apply-templates>
							</xsl:for-each>
						</xsl:when>
						<xsl:when test="$subnamespace = 'simmep'">
							<xsl:for-each select="msxsl:node-set($simmep)">
								<xsl:apply-templates select="key('kxsComplexTypeByName_simmep', $localname)">
									<xsl:with-param name="pElement" select="localname"/>
									<xsl:with-param name="pUnsortedItemList" select="$pUnsortedItemList"/>
								</xsl:apply-templates>
							</xsl:for-each>
						</xsl:when>
					</xsl:choose>
				</xsl:if>
				<xsl:apply-templates mode="generate" select="current()/xs:complexContent/xs:extension/xs:sequence/*">
					<xsl:with-param name="pParent" select="$pElement"/>
					<xsl:with-param name="pUnsortedItemList" select="$pUnsortedItemList"/>
				</xsl:apply-templates>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<xsl:template match="xs:element">
		<xsl:param name="pElement"/>
		<xsl:param name="pUnsortedItemList"/>
		<xsl:apply-templates mode="order" select="current()/xs:complexType/xs:sequence/*">
			<xsl:with-param name="pParent" select="$pElement"/>
			<xsl:with-param name="pUnsortedItemList" select="$pUnsortedItemList"/>
		</xsl:apply-templates>
	</xsl:template>
	<xsl:template match="xs:element" mode="generate">
		<xsl:param name="pParent"/>
		<xsl:param name="pUnsortedItemList"/>
		<xsl:variable name="CurrentSequenceElementName" select="@ref | @href"/>
		<xsl:for-each select="msxsl:node-set($pUnsortedItemList)/*">
			<xsl:if test="$CurrentSequenceElementName = name()">
				<xsl:copy-of select="current()"/>
			</xsl:if>
		</xsl:for-each>
	</xsl:template>
	<xsl:template match="xs:element" mode="order">
		<xsl:param name="pParent"/>
		<xsl:param name="pUnsortedItemList"/>
		<xsl:variable name="CurrentSequenceElementName" select="@name"/>
		<xsl:for-each select="msxsl:node-set($pUnsortedItemList)/*">
			<xsl:if test="$CurrentSequenceElementName = name()">
				<xsl:copy-of select="current()"/>
			</xsl:if>
		</xsl:for-each>
	</xsl:template>
</xsl:stylesheet>
